
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>泛函编程（15）－泛函状态－随意数产生器 / iVAN</title>

    <meta name="description" content="泛函编程（15）－泛函状态－随意数产生器   对于OOP程序员来说,泛函状态变迁(functional state transition)是一个陌生的课题.泛函状态变迁是通过泛函状态数据类型(functional state)来实现的.State是一个出现在泛函编程里的类型(type).与其它数据类型一样,State同样需要自身的一套泛函操作函数和组合函数(combinators),我们将在以下章节中讨论有关State数据类型的设计方案.      在正式介绍State类型前,我们先从随意数产生器(RNG: Random Number">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">泛函编程（15）－泛函状态－随意数产生器</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>  对于OOP程序员来说，泛函状态变迁（functional state transition）是一个陌生的课题。泛函状态变迁是通过泛函状态数据类型（functional state）来实现的。State是一个出现在泛函编程里的类型（type）。与其它数据类型一样，State同样需要自身的一套泛函操作函数和组合函数（combinators），我们将在以下章节中讨论有关State数据类型的设计方案。</p>
<p>     在正式介绍State类型前，我们先从随意数产生器（RNG: Random Number Generator）开始，从泛函RNG的原理分析引领到State设计方案。</p>
<p>先看看我们熟悉的java RNG:</p>
<pre><code>1 //java code
2 val rng = new java.util.Random                    //&gt; rng  : java.util.Random = java.util.Random@48533e64
3
4 rng.nextInt                                       //&gt; res0: Int = -1412360869
5 rng.nextInt                                       //&gt; res1: Int = 645622520
6
7 rng.nextDouble                                    //&gt; res2: Double = 0.4216477872043267
8 rng.nextDouble                                    //&gt; res3: Double = 2.306856098814869E-4</code></pre>
<p>这个肯定不是泛函风格的RNG：同一个函数每次引用会产生不同的结果。泛函函数（pure function）的“等量替换”在这里不成立。再者，我们不难想象在以上rng里一定维护了一个状态，每次更新，产生了附带影响（side effect），这又违背了泛函纯函数（pure function）的不产生附带影响的要求（referencial transparency）。那么应该怎么办呢？泛函的做法重点在于用明确的方式来更新状态，即：不要维护内部状态，直接把新状态和结果一道返回，像下面这样：</p>
<pre><code>1 trait RNG {
2   def nextInt: (Int, RNG)
3 }</code></pre>
<p>从以上方式我们基本能得出泛函状态变迁（state transition）的款式：</p>
<p>假设我们有这么个类型结构：</p>
<pre><code>1 class Foo {
2   var s: FooState = ...
3   def bar: Bar
4   def baz: Int
5 }</code></pre>
<p>如果 bar 和 baz 会改变 Foo 的状态，那么我们应该这样设计bar, baz 函数：</p>
<pre><code>1 trait Foo {
2   def bar: (Bar, Foo)
3   def baz: (Int, Foo)
4 }</code></pre>
<p>好，那么我们试试设计泛函式的随意数产生器RNG：</p>
<pre><code> 1 trait RNG {
 2     def nextInt: (Int, RNG)
 3 }
 4 //起始状态RNG, 种子RNG
 5 case class seedRNG(seed: Long) extends RNG {
 6     def nextInt: (Int, RNG) = {
 7      val seed2 = (seed*0x5DEECE66DL + 0xBL) &amp; ((1L &lt;&lt; 48) - 1)
 8      ((seed2 &gt;&gt;&gt; 16).asInstanceOf[Int], seedRNG(seed2))
 9     }
10 }
11 val rng = seedRNG(System.currentTimeMillis)       //&gt; rng  : ch6.rng.seedRNG = seedRNG(1427201377395)
12 val (i,rng2) = rng.nextInt                        //&gt; i  : Int = 1516062234
13                                                   //| rng2  : ch6.rng.RNG = seedRNG(99356654630658)
14 val (i2,rng3) = rng2.nextInt                      //&gt; i2  : Int = 483165502
15                                                   //| rng3  : ch6.rng.RNG = seedRNG(31664734402533)
16 val (i3,rng4) = rng2.nextInt                      //&gt; i3  : Int = 483165502
17                                                   //| rng4  : ch6.rng.RNG = seedRNG(31664734402533)</code></pre>
<p>函数nextInt返回了一个随意数及新的RNG。如果我们使用同一个RNG产生的结果是一样的r2==r3，恰恰体现了泛函风格。</p>
<p>所有类型的泛函式随意数产生器都可以从Int RNG nextInt推导出来：</p>
<pre><code> 1 object RNG {
 2   //值在 0.0 - 1.0 之间的Double随意数
 3     def nextDouble(rng: RNG): (Double, RNG) = {
 4         val (i,rng2) = rng.nextInt
 5         if ( i == Int.MaxValue ) (0.0, rng2)
 6         else ( i.toDouble / Int.MaxValue.toDouble, rng2)
 7     }
 8     def nextPositiveInt(rng: RNG): (Int, RNG) =  {
 9         val (i, rng2) = rng.nextInt
10         if ( i == Int.MaxValue ) (Int.MaxValue, rng2)
11         else (i.abs, rng2)
12     }
13     def nextBoolean(rng: RNG): (Boolean, RNG) = {
14         rng.nextInt match {
15             case (i, rng2) =&gt; (i % 2 == 0, rng2)
16         }
17     }
18     //产生一个随意tuple (Int, Double)
19     def nextIntDouble(rng: RNG): ((Int, Double), RNG) = {
20         val (i,rng2) = nextPositiveInt(rng)
21         val (d,rng3) = nextDouble(rng2)
22         ((i,d),rng3)
23     }
24     //产生一个随意数的n长度List
25     def nextInts(n: Int)(rng: RNG): (List[Int], RNG) = {
26         def go(n: Int, rng: RNG, acc: List[Int]): (List[Int], RNG) = {
27              if ( n &lt;= 0 ) (acc, rng)
28              else {
29                  val (i,rng2) = rng.nextInt
30               go(n-1,rng2,i :: acc)
31              }
32         }
33         go(n,rng,Nil: List[Int])
34     }
35 }
36 import RNG._
37
38 val rng = seedRNG(System.currentTimeMillis)       //&gt; rng  : ch6.rng.seedRNG = seedRNG(1427204725766)
39 val (d, rng5) = nextDouble(rng)                   //&gt; d  : Double = 0.6090536781628866
40                                                   //| rng5  : ch6.rng.RNG = seedRNG(85716684903065)
41 val (b, rng6) = nextBoolean(rng5)                 //&gt; b  : Boolean = false
42                                                   //| rng6  : ch6.rng.RNG = seedRNG(123054239736112)
43 val ((i5,d2), rng7) = nextIntDouble(rng6)         //&gt; i5  : Int = 1054924659
44                                                   //| d2  : Double = 0.8877875771782303
45                                                   //| rng7  : ch6.rng.RNG = seedRNG(124944993788778)
46 val (ints, rng8) = nextInts(5)(rng7)              //&gt; ints  : List[Int] = List(-782449771, -1992066525, -825651621, -440562357, 7
47                                                   //| 00809062)
48                                                   //| rng8  : ch6.rng.RNG = seedRNG(230196348539649)</code></pre>
<p>从以上的例子中可以发现这些函数一致的款式：func(RNG):(A,RNG)，即：RNG =&gt; (A,RNG)， 是lambda function，纯纯的函数类型申明。这样看来随意数产生器就是一个函数类型，我们可以把产生器当作函数的参数或者返回值来使用。那么我们可以自创一个新的类型：</p>
<pre><code>1     type Rand[+A] = RNG =&gt; (A, RNG)</code></pre>
<p>Rand就是一个随意数产生器，我们是可以把它传来传去的。那么下面我们就试着使用Rand类型：</p>
<pre><code> 1 type Rand[+A] = RNG =&gt; (A, RNG)
 2
 3     def rnInt: Rand[Int] = _.nextInt
 4     def rnPositiveInt: Rand[Int] = nextPositiveInt
 5 }
 6 import RNG._
 7
 8 val rng = seedRNG(System.currentTimeMillis)       //&gt; rng  : ch6.rng.seedRNG = seedRNG(1427239224137)
 9 rnInt(rng)                                        //&gt; res0: (Int, ch6.rng.RNG) = (-1225681606,seedRNG(201148706995232))
10 rnPositiveInt(rng)                                //&gt; res1: (Int, ch6.rng.RNG) = (1225681606,seedRNG(201148706995232))</code></pre>
<p>在以上例子里我们可能注意到了一些别扭的东西：函数申明 def rnInt: Rand[Int] 好像没有参数，但使用时 rnInt(rng) 是需要参数的。不过如果我们想想 Func(RNG):(A,RNG) 的lambda表达形式 RNG =&gt; (A,RNG)自然就理解了。</p>
<p>既然我们已经把随意数产生器变成了Rand类型，我们应该可以方便地对随意数产生器进行组合、变形了吧？先看一个最基本的组件（combinator）：</p>
<pre><code>1     def unit[A](a: A): Rand[A] = {
2         rng =&gt; (a, rng)
3     }</code></pre>
<p>乍看起来这个unit好像没什么用，没做什么事。实际上unit可以说是函数组合的最基本组件，是大大的有用的。unit只有一个作用：把a包进高阶类Rand里，换句话说就是把低阶类A升格到高阶Rand，这样就可以和其它Rand进行组合或者使用Rand函数自我变形了。这个简单的例子再次提示了从返回类型来推导功能实现这种泛函编程风格：Band[A] &gt;&gt;&gt; RNG =&gt; (A, RNG) 即：给我一个RNG我就可以返回一个(A, RNG)。</p>
<p>再来一个针对Rand类型的map：</p>
<pre><code>1     def map[A,B](ra: Rand[A])(f: A =&gt; B): Rand[B] = {
2       rng =&gt; {
3                 val (x, rng2) = ra(rng)
4                 (f(x), rng2)
5         }</code></pre>
<p>从以上函数的实现方式可以得出map就是对一个随意数产生器的结果进行转换后仍然保留Rand的高阶类型格式。还和上一个例子一样：我们一看到返回类型Rand就应该立刻想到 rng =&gt; {...(a2, rng2)}这种实现风格了。</p>
<p>举出个使用map的例子：</p>
<pre><code>1     def rnDouble: Rand[Double] = { map(rnPositiveInt){ _ / (Int.MaxValue.toDouble + 1) } }
2 val rng = seedRNG(System.currentTimeMillis)       //&gt; rng  : ch6.rng.seedRNG = seedRNG(1427245671833)
3 rnDouble(rng)                                     //&gt; res0: (Double, ch6.rng.RNG) = (0.6156660546548665,seedRNG(86647294261296))</code></pre>
<p>真够简洁的。下面再试着结合两个Rand：</p>
<pre><code>1     def map2[A,B,C](ra: Rand[A], rb: Rand[B])(f: (A,B) =&gt; C): Rand[C] = {
2         rng =&gt; {
3             val (x,rng2) = ra(rng)
4             val (y,rng3) = rb(rng2)
5             (f(x,y), rng3)
6         }
7     }</code></pre>
<p>真够简洁的。下面再试着结合两个Rand：</p>
<pre><code>1     def map2[A,B,C](ra: Rand[A], rb: Rand[B])(f: (A,B) =&gt; C): Rand[C] = {
2         rng =&gt; {
3             val (x,rng2) = ra(rng)
4             val (y,rng3) = rb(rng2)
5             (f(x,y), rng3)
6         }
7     }</code></pre>
<p>写几个使用map2的例子：</p>
<pre><code>1     def rnPair[A,B](ra: Rand[A], rb: Rand[B]): Rand[(A, B)] = {
 2         map2(ra,rb){(_,_)}
 3     }
 4     def rnIntDoublePair: Rand[(Int, Double)] = {
 5         rnPair(rnInt,rnDouble)
 6     }
 7     def rnDoubleIntPair: Rand[(Double, Int)] = {
 8         rnPair(rnDouble,rnInt)
 9     }
10 }
11 import RNG._
12
13 val rng = seedRNG(System.currentTimeMillis)       //&gt; rng  : ch6.rng.seedRNG = seedRNG(1427246457588)
14 rnIntDoublePair(rng)                              //&gt; res0: ((Int, Double), ch6.rng.RNG) = ((-1302173232,0.355998701415956),seedR
15                                                   //| NG(231372613633230))
16 rnDoubleIntPair(rng)                              //&gt; res1: ((Double, Int), ch6.rng.RNG) = ((0.6063716635107994,-764501390),seedR
17                                                   //| NG(231372613633230))</code></pre>
<p>既然我们能用map2来结合两个Rand，那么能不能把一个List里面的Rand结合成一个Rand呢？</p>
<pre><code> 1     //用递归方式
 2     def sequence[A](lr: List[Rand[A]]): Rand[List[A]] = {
 3       rng =&gt; {
 4           def go(xs: List[Rand[A]], r: RNG, acc: List[A]): (List[A], RNG) = {
 5               lr match {
 6                     case Nil =&gt; (acc,rng)
 7                     case h :: t =&gt; {
 8                         val (x, rng2) = h(rng)
 9             go(t,rng2,x::acc)
10                   }
11               }
12           }
13           go(lr,rng,List())
14         }
15     }
16     //用foldRight实现
17     def sequence_1[A](lr: List[Rand[A]]): Rand[List[A]] = {
18        lr.foldRight(unit(Nil: List[A])) {(h,t) =&gt; map2(h,t)(_ :: _)}
19     }</code></pre>
<p>从以上foldRight实现方式可以体会unit的作用：它把List[A］升了格，这样才能与Rand的map2类型匹配。可以发现使用了map,map2,sequence去操作Rand时，我们已经无须理会这个RNG了，这证明我们已经向着更高的抽象层进步了，这也是泛函编程的真义所在。但是光靠map,map2,sequence就可以办成所有的事了吗？不是！想想那个正整数随意数产生器positiveInt，如果用rnInt产生了Int.MinValue的话就重新再产生一个，直到产生出一个不为Int.MinValue的数。我们试着用map来实现：</p>
<pre><code>1 def positiveInt: Rand[Int] = {
2   map(int) { i =&gt;
3     if (i != Int.MinValue) i.abs else ??
4   }
5 }</code></pre>
<p>map的操作函数类型是f: A =&gt; B，重复运算positiveInt返回类型是Rand[A], 不匹配，我们就卡在这了。但再看看这个问题可以用flatMap解决：因为flatMap的操作函数f: A =&gt; Rand[B], 类型是匹配的。我们可以用unit把 i.abs升格就可以使用flatMap解决问题了。</p>
<p>赶快实现flatMap:</p>
<pre><code>1     def flatMap[A,B](ra: Rand[A])(f: A =&gt; Rand[B]): Rand[B] = {
 2         rng =&gt; {
 3             val (x, rng2) = ra(rng)
 4             f(x)(rng2)
 5         }
 6     }
 7     def positiveIntByFlatMap: Rand[Int] = {
 8         flatMap(rnInt) {
 9             a =&gt; {
10                 if ( a != Int.MinValue) unit(a.abs)
11                 else positiveIntByFlatMap
12             }
13         }
14     }</code></pre>
<p>没错，可以用flatMap实现positiveInt了。那么用flatMap可以实现map,map2吗？看看下面的具体实现方法：</p>
<pre><code>1   def mapByFlatMap[A,B](ra: Rand[A])(f: A =&gt; B): Rand[B] = {
2       flatMap(ra){ a =&gt; unit(f(a)) }
3   }
4   def map2ByFlatMap[A,B,C](ra: Rand[A], rb: Rand[B])(f: (A,B) =&gt; C): Rand[C] = {
5         flatMap(ra){ a =&gt; map(rb) {b =&gt; f(a,b)}}
6   }
7   def map3ByFlatMap[A,B,C,D](ra: Rand[A], rb: Rand[B], rc: Rand[C])(f: (A,B,C) =&gt; D): Rand[D] = {
8         flatMap(ra){ a =&gt; flatMap(rb) {b =&gt; map(rc) {c =&gt; f(a,b,c)}}}
9   }</code></pre>
<p>看，代码是不是越来越简洁了？而且仿佛进入了数学世界。我是说现在感觉编程已经变成了好像高中做数学题一样：拿到一个函数描述就开始想办法用什么其它现有的函数来解决；然后匹配一下类型，找找以前的例子，等等。。。,完全没有感觉到是在编写计算机程序。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-01 16:51:43</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e7%bc%96%e7%a8%8b%e8%af%ad%e8%a8%80/" title="编程语言">编程语言</a>, <a href="https://www.iamivan.net/tag/scala/" title="scala">scala</a>, <a href="https://www.iamivan.net/tag/programming/" title="Programming">Programming</a>, <a href="https://www.iamivan.net/tag/functional/" title="Functional">Functional</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>泛函编程（15）－泛函状态－随意数产生器的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zVw4KVb.html" rel="bookmark">泛函编程（5）－数据结构（Functional Data Structures&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  编程即是编制对数据进行运算的过程.特殊的运算必须用特定的数据结构来支持有效运算.如果没有数据结构的支持,我们就只能为每条数据申明一个内存地址了,然后使用这些地址来操作这些数据,也就是我们熟悉的申明变量再对变量进行读写这个过程了.试想想如果没有数据结构,那我们要申明多少个变量呢.所以说,数据结构是任何编程不可缺少的元素.     泛函编程使用泛函数据结构(Functional Data Structure)来支持泛函程序.泛函数据结构的特点是&quot;不可变特性&quot;(Immutability)			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M0QNd0p.html" rel="bookmark">泛函编程（16）－泛函状态－Functional State</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				    初接触泛函状态觉着很不习惯.主要是在使用State数据类型时很难理解其中的原理,特别是泛函状态变迁机制(state transition mechanism):怎么状态就起了变化,实在难以跟踪.我想这主要是因为状态变迁机制经过了函数组合,已经深深的埋藏在运行代码后面.上节我们讨论到RNG,对于了解State类型是个很好的开头.RNG简单描述了泛函方式的状态变迁及支持状态变迁所需要的数据结构和操作函数款式.     在上节我们提到过 type Rand[+A] = RNG =&gt; (A, R			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MYjxAxp.html" rel="bookmark">泛函编程（34）－泛函变量：处理状态转变－ST Monad</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  泛函编程的核心模式就是函数组合(compositionality).实现函数组合的必要条件之一就是参与组合的各方程序都必须是纯代码的(pure code).所谓纯代码就是程序中的所有表达式都必须是Referentially Transparent(RT,等量可替换的),它的意思是:在一段程序p中,所有的表达式e都可以用e的运算结果替代而不影响到p的运算结果,那么e就是RT等量可替换的,也就是说程序p是由纯代码组成的.但如果程序p中包含了一些变量,这些变量的状态就会影响到程序中e的运算结果,那			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pXqj2lz.html" rel="bookmark">泛函编程（38）－泛函Stream IO：IO Process in action</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				 在前面的几节讨论里我们终于得出了一个概括又通用的IO Process类型Process[F[_],O].这个类型同时可以代表数据源(Source)和数据终端(Sink).在这节讨论里我们将针对Process[F,O]的特性通过一些应用实例来示范它的组合性(composibility)和由数据源到接收终端IO全过程的功能完整性.   我们已经在前面的讨论中对IO Process的各种函数组合进行了调研和尝试,现在我们先探讨一下数据源设计方案:为了实现资源使用的安全性和IO程序的可组合性,我们必须			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/0bod3DM.html" rel="bookmark">泛函编程（25）－泛函数据类型－Monad－Applicative</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				    上两期我们讨论了Monad.我们说Monad是个最有概括性(抽象性)的泛函数据类型,它可以覆盖绝大多数数据类型.任何数据类型只要能实现flatMap+unit这组Monad最基本组件函数就可以变成Monad实例,就可以使用Monad组件库像for-comprehension这样特殊的.Monad具备的泛函式数据结构内部的按序计算运行流程.针对不同的数据类型,flatMap+unit组件实现方式会有所不同,这是因为flatMap+unit代表着承载数据类型特别的计算行为.之前我们尝试了Li			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MxW17Pb.html" rel="bookmark">泛函编程（6）－数据结构－List基础</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				    List是一种最普通的泛函数据结构,比较直观,有良好的示范基础.List就像一个管子,里面可以装载一长条任何类型的东西.如需要对管子里的东西进行处理,则必须在管子内按直线顺序一个一个的来,这符合泛函编程的风格.与其它的泛函数据结构设计思路一样,设计List时先考虑List的两种状态:空或不为空两种类型.这两种类型可以用case class 来表现: 1 trait List[+A] {} 2 case class Cons[+A](head: A, tail: List[A]) exte			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/ze7JR9M.html" rel="bookmark">泛函编程（9）－异常处理－Option</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				    Option是一种新的数据类型.形象的来描述:Option就是一种特殊的List,都是把数据放在一个管子里:然后在管子内部对数据进行各种操作.所以Option的数据操作与List很相似.不同的是Option的管子内最多只能存放一个元素,在这个方面Option的数据操作就比List简单的多,因为使用者不必理会数据元素的位置.顺序.Option只有两种状态:包含一个任何类型的元素或者为空.或者这样讲:一个Option实例包含 0 或 1 个元素:None代表为空,Some(x)代表包含一个任			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M6NA6yM.html" rel="bookmark">泛函编程（29）－泛函实用结构：Trampoline-不再怕StackOverflow</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  泛函编程方式其中一个特点就是普遍地使用递归算法,而且有些地方还无法避免使用递归算法.比如说flatMap就是一种推进式的递归算法,没了它就无法使用for-comprehension,那么泛函编程也就无法被称为Monadic Programming了.虽然递归算法能使代码更简洁易明,但同时又以占用堆栈(stack)方式运作.堆栈是软件程序有限资源,所以在使用递归算法对大型数据源进行运算时系统往往会出现StackOverflow错误.如果不想办法解决递归算法带来的StackOverflow问题,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MlQ0EOp.html" rel="bookmark">泛函编程（32）－泛函IO：IO Monad</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				 由于泛函编程非常重视函数组合(function composition),任何带有副作用(side effect)的函数都无法实现函数组合,所以必须把包含外界影响(effectful)副作用不纯代码(impure code)函数中的纯代码部分(pure code)抽离出来形成独立的另一个纯函数.我们通过代码抽离把不纯代码逐步抽离向外推并在程序里形成一个纯代码核心(pure core).这样我们就可以顺利地在这个纯代码核心中实现函数组合.IO Monad就是泛函编程处理副作用代码的一种手段.我们			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/0boLejM.html" rel="bookmark" class="title">如何让交互过程变得惊喜有趣？</a>
					<div>
						  编者按:今天的交互,就像是引诱小孩子吃药的方糖,不但味道得甜,过程还要润物无声,是个不小的考验.今天网易的美女交互设计大神@子木yoyo 分享了6个最流行的交互设计方法,附优秀案例,通俗易懂,可以 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/aM65eLb.html" rel="bookmark" class="title">优秀的Google产品经理需要具备哪些素质？</a>
					<div>
						文章描述:如何在Google成为一名优秀的产品经理? 导读:有用户在Quora提问:优秀的Google产品经理需要具备哪些素质?前 Google 工程师 Edward Ho 回复了这个问题.编译Edw ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OMy1WkM.html" rel="bookmark" class="title">用模板实现代码和页面的分离</a>
					<div>
						模板|页面 为了避免ASP程序和HTML代码混写造成维护困难的情况,本文介绍了一种方法,利用模板来分离程序和页面,使程序设计更加轻松. 在使用ASP制作一个站点的时候,常常会出现一个ASP文件中,程序 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/gpkBowM.html" rel="bookmark" class="title">学习ASP之编写安全的ASP代码</a>
					<div>
						安全 ASP中数据库的安全是一个很严肃的问题.很多代码的编写者意识到了这类问题,并且小心翼翼地对他们认为有问题的地方做了补救,但常见的情况是要么没有穷尽所有的可疑地点,要么这种补救逻辑上有误.对于一个 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/jbE2BZM.html" rel="bookmark" class="title">用Java实现可保存状态的数据库生成XML树（2）</a>
					<div>
						xml|生成xml|数据|数据库 4.3.构造生成XML的servlet这一步的主要实现是从数据表中提取符合要求的记录生成嵌套的XML,servlet的源码是XMLServlet.java,选用ora ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2yydQz.html" rel="bookmark" class="title">AJAX处理书签和翻页按扭</a>
					<div>
						本篇文章提供了一个开源JavaScript库,它提供了给AJAX应用程序中添加书签和会退按钮的功能.在学习完这个教程后,开发者将能够对开发AJAX应用碰到的问题获得一个解决方案,这个特性甚至Googl ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnxYyKb.html" rel="bookmark" class="title">Oracle的EXPDP和IMPDP命令使用详解</a>
					<div>
						Data Pump包括导出表,导出方案,导出表空间,导出数据库4种方式. 1.EXPDP命令参数及说明 (1) ATTACH 该选项用于在客户会话与已存在导出作用之间建立关联.语法如下 ATTACH= ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgKWK6M.html" rel="bookmark" class="title">职业院校的学分制管理</a>
					<div>
						职业院校信息化建设是实现学分制管理的基础,是基于现代信息网络技术的教育体系.职业教育信息化不是计算机.网络.职业教育的简单相加,而是职业教育理念.教学.管理.学习与现代信息网络技术的有机融合,从而形成 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvK5L9p.html" rel="bookmark" class="title">如何获得CPU使用率</a>
					<div>
						NT/2000方法: #include &lt;windows.h&gt;#include &lt;conio.h&gt;#include &lt;stdio.h&gt;#define SystemB ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRyWk8b.html" rel="bookmark" class="title">js 得到文件后缀&lpar;通过正则实现&rpar;</a>
					<div>
						使用js获取文件的后缀,有个不错的正则,大家可以借用下,具体如下,感兴趣的朋友可以参考下哈,希望对大家有所帮助   正则得到后缀 复制代码 代码如下: &lt;script type=&quot;te ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M91w7oM.html" rel="bookmark" class="title">傲游&OpenCurlyDoubleQuote;一键搞定&rdquo;让操作更加得心应手</a>
					<div>
						  定制1:网页浏览一键恢复&quot;记忆力&quot; 朋友通过QQ及MSN发过来了许多精彩文章的推荐链接,我们逐一打开链接,美滋滋的欣赏着,这时IE浏览器却因为意外崩溃而退出,相信许多朋友都遇到 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mg3RAmM.html" rel="bookmark" class="title">5大电脑小技巧推荐 让操作变得简单</a>
					<div>
						让我们一起分享这些有趣又好玩的电脑小技巧.其中有如何提升电脑使用速度的方法,有优化系统的方法等等,如果你没有用过,不妨来试试,如果你是 高手也欢迎来拍砖,不过拍砖的同时还希望您亮出自己的使用技巧供大家 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZd2akM.html" rel="bookmark" class="title">Photoshop CS6安装失败怎么办</a>
					<div>
						  Photoshop CS6安装失败很可能是以前安装过Photoshop的绿色版,但卸载不彻底,导致安装完全版的时候出现这个错误. 解决办法:删除C:Program FilesCommon File ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkGVg1p.html" rel="bookmark" class="title">调出深受年轻女孩喜欢的日系清新色调</a>
					<div>
						  先简单说说.日系色调是现在很多摄影师热爱的风格,那种甜美清新可爱的感觉扑面而来,也让深受很多年轻女孩子的热爱,那么今天摄影师ahwin(微信:hanbowen)实例来详细解说,日系色调的后期调整和 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEWgP6p.html" rel="bookmark" class="title">快牙电脑版怎么用？</a>
					<div>
						  快牙电脑版需要电脑端有无线网卡的硬件支持否则无法使用,在电脑端启动快牙电脑版,自动创建热点网络.可以看到快牙电脑版提示客户端可与安卓和苹果设备互联. 图1 快牙电脑版软件界面 点击下方红框中的区域 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvGLlVp.html" rel="bookmark" class="title">认识优化大师操作界面</a>
					<div>
						优化大师界面说明 (1)模块选择 Windows优化大师四大功能模块,包括系统检测.系统优化.系统清理和系统维护. (2)功能选择 Windows优化大师四大功能模块下的具体小模块,详细说明请参照各模 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnY9r2M.html" rel="bookmark" class="title">Keynote怎么格式化文本</a>
					<div>
						  在设备上启用任何中文.日文或韩文键盘时,Keynote 会提供一些特定于语言的文本格式化功能,包括强调样式.列表样式和拼音指南.格式化选项是否可用,取决于您所启用的语言键盘. 若要获得最佳效果,请 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq85mYb.html" rel="bookmark" class="title">Lightroom将照片修得通透亮丽呢？</a>
					<div>
						  风格:清新通透;主题:路过夏天,微风吹拂你的微笑;将照片修得通透亮丽呢?我所使用的修图方法,当然,每个人都有自己独特修图的方法,能达到一样的效果即可!					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z42lJqM.html" rel="bookmark" class="title">udf-关于ansys fluent中level set function</a>
					<div>
						问题描述 关于ansys fluent中level set function ANSYS fluent 在v14和v14.5两相流模型都添加了level set 函数,与VOF模型couple,但是我 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEW37Ap.html" rel="bookmark" class="title">我们为什么需要Greenplum？</a>
					<div>
						以下内容根据演讲PPT以及现场分享整理而成. 数据分析业务模型 首先介绍一下数据分析的业务模型,以及遇到的问题.博雅立方作为一家数据分析的公司,数据来源是非常多样的,而且我们未来希望形成一个大型的平台 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq8Xa2b.html" rel="bookmark" class="title">guava之Joiner 和 Splitter</a>
					<div>
						最近在给客户准备一个Guava的分享,所以会陆续的更新关于Guava更多的细节分享.本文将记录Guava中得字符串处理Joiner(连接)和Splitter(分割)处理. Joiner 首先我们来看看 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0QeQPp.html" rel="bookmark" class="title">大神来帮帮菜鸟，在网上下载了sqlhelper，提示上下文中不存在sqlhelper</a>
					<div>
						问题描述 在网上买了班vs2013项目教学,是图书馆管理系统,按照书上的现在出问题了,求大神帮帮忙,书上说网上下载一个sqlhelper.cs,添加了,直接写代码SqlDataReaderdr=Sql ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bB10LJz.html" rel="bookmark" class="title">【理想流】项目管理本质论 &period;</a>
					<div>
						引言 在项目管理这样的领域中有一种很不好的趋势,那就是许多局中人逐渐的迷失自我.而在偏向社会学的领域中,一旦我们相信理论多于相信自己,也就意味着我们开始犯错. 项目管理是与数学等自然科学完全不同的学科 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boKo6vb.html" rel="bookmark" class="title">SQL SERVER使用ODBC 驱动建立的链接服务器调用存储过程时参数不能为NULL值</a>
					<div>
						   我们知道SQL SERVER建立链接服务器(Linked Server)可以选择的驱动程序非常多,最近发现使用ODBC 的 Microsoft OLE DB 驱动程序建立的链接服务器(Linke ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPBjYmb.html" rel="bookmark" class="title">Hibernate Core 4&period;0&period;0&period;Alpha1发布 Java语言对象关系映射解决方案</a>
					<div>
						Hibernate是一种Java语言下的对象关系映射解决方案.它是使用GNU宽通用公共许可证发行的自由.开源的软件.它为面向对象的领域模型到传统的关系型数据库的映射,提供了一个使用方便的框架.Hibe ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnKvXjz.html" rel="bookmark" class="title">网络犯罪：令牌化和区块链将终结数据盗窃行为？</a>
					<div>
						一段时间以来,美国各行业一直是信用卡欺诈和数据窃取的温床.在信用卡欺诈方面,大数据分析已成为打击欺诈行为的前沿技术,仅在2013年就损失超过70亿美元.数据科学家创建分析用户习惯的算法,并使用机器学习 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1rgv8p.html" rel="bookmark" class="title">pl sql-orcal 存储过程第一次写，编译的时候报错，大侠帮帮忙，急！！</a>
					<div>
						问题描述 orcal 存储过程第一次写,编译的时候报错,大侠帮帮忙,急!! sql脚本如下:create or replace procedure &quot;&quot;PageList&quot; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b22ZGQb.html" rel="bookmark" class="title">《Visual C&plus;&plus; 开发从入门到精通》&mdash;&mdash;第2章 C&plus;&plus;的基本语法2&period;1　面向对象</a>
					<div>
						第2章 C++的基本语法 Visual C++ 开发从入门到精通 学习Visual C++ 6.0开发知识,需要具备C++语言的基本知识,特别是语法知识.C++是继C语言之后的又一门受程序员欢迎的编程 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvYvV9b.html" rel="bookmark" class="title">深入理解Java中的字符串类型&lowbar;java</a>
					<div>
						1.Java内置对字符串的支持: 所谓的内置支持,即不用像C语言通过char指针实现字符串类型,并且Java的字符串编码是符合Unicode编码标准,这也意味着不用像C++那样通过使用string和w ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1NX9ap.html" rel="bookmark" class="title">KnockoutJS 3&period;X API 第四章之表单submit、enable、disable绑定&lowbar;javascript技巧</a>
					<div>
						Knockout是一个以数据模型(data model)为基础的能够帮助你创建富文本,响应显示和编辑用户界面的JavaScript类库.任何时候如果你的UI需要自动更新(比如:更新依赖于用户的行为或者 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.033 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
